c Last modif: 
c            27 november 2007: added factors to have apparent magnitudes 
c            normalized to 1 M_sun
      PROGRAM evolcolorplus
      IMPLICIT NONE
      INTEGER maxw,mxft,mxwf,mxfil,maxt,input,nparam,i,nz,iz,
     .     ii,iii,j,k,l,kfil,icomp,nfil,iblank,ityp,mxtyp,
     .     iread,iw,jread,last,nf,np,ncomp,n_filter,n_files,
     .     mag_typ,kecorr,ks,i1,i2,lyf,iw_vega,law_rd,mag_frame,
     .     lnblnk
      PARAMETER (nparam=17,maxw=10000,maxt=225,mxfil=30,mxtyp=100)
      REAL*8 y,yob,amag,bp1,dz,f,t_bc,h0,om,ov,r,surf,w,wl,z0,c,
     .     av,w_vega,f_vega,flux,z,vega,z_max,z_min,z_form,filter,ww,
     .     abconv,color,tz,age_form,age_uni,age_z,age,tx,t1,t2,
     .     a1,a2,fnu_vega,rnu_vega,wrnu,rrnu,ffnu,ff1,ff2,trapz1,rlin,
     .     amabs,fluxz0,dl,d_l,rnorm,scl,factmass,pi4
      PARAMETER (pi4=3.141592654D0*4.D0)
      REAL w_bc,t_bc0,f_bc,f_as,w_as,wv,fv
c       mxft = 300 = maximum number of filters
c       mxwf = 200 = maximum number of wavelengths/filter
      CHARACTER NAMECH(mxtyp)*160,line*160
      CHARACTER*160 spectra1,filein,filt_file,fmt,file_def,line_sed
      CHARACTER*160 spec_vega,filtresfile
      CHARACTER*40 cname,param(nparam),sed_abc(mxtyp)*2
      INCLUDE 'filter.dec'

      DIMENSION input(nparam),y(maxw),yob(maxw),iw(mxtyp)
      DIMENSION nfil(mxfil),amag(mxfil),amabs(mxfil),kfil(10)
      DIMENSION f_bc(maxw,maxt,mxtyp),f_as(maxw,mxtyp),f(maxw,maxt)
      DIMENSION t_bc0(maxt),t_bc(maxt),ks(mxtyp),rnorm(mxtyp)
      DIMENSION vega(mxfil),wl(mxfil),surf(mxfil),abconv(mxfil)
      DIMENSION w_bc(maxw,mxtyp),w_as(maxw,mxtyp),ww(maxw)
      DIMENSION fnu_vega(4000),rnu_vega(4000)
      DIMENSION wrnu(mxwf),rrnu(mxwf),ffnu(mxwf)
      DIMENSION w_vega(4000),f_vega(4000)

      COMMON /compose/ icomp
      COMMON /namefile/ spec_vega
      COMMON /filterres/ filtresfile

      EXTERNAL filter,color,tz,rlin,trapz1,d_l
c_________________________________________________________________________

      jread=0                   !Control on reading A0VSED
      iread=0                   !Control on reading Filter Library
      law_rd=5
      c=2.9979D+18              ! speed of light in AA/s
      scl=2.D-17
      factmass=pi4*3.085678D0*3.085678D48/3.826D33

      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='TEMPLATES_FILE'
      param(4)='FILTERS_FILE'
      param(5)='MAG_TYPE'
      param(6)='MAG_FRAME'
      param(7)='K_E_CORR'
      param(8)='H_0'
      param(9)='OMEGA_M'
      param(10)='OMEGA_V'
      param(11)='Z_FORM'
      param(12)='Z_MIN'
      param(13)='Z_MAX'
      param(14)='Z_STEP'
      param(15)='LY_FOREST'
      param(16)='FILE_OUT'
      param(17)='A_V'
      DO i=1,nparam
         input(i)=0
      END DO

 44   filein='colour_plus.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file' 
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ (*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)') filein
      END IF

      OPEN(77,FILE=filein,STATUS='old',ERR=44)
 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c ..... A0VSED file
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c .... FILTER.RES file
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing templates names
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') file_def
         input(3)=1
         GO TO 7
c ..... File containing filters
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filt_file
         input(4)=1
         GO TO 7
c ..... Magnitude type: 0. Vega 1. AB
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) mag_typ
         input(5)=1
         GO TO 7
c ..... Magnitude frame: 0. observed 1. rest
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) mag_frame
         input(6)=1
         GO TO 7
c ..... k or k+e correction (k default if sed_abc=A)
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) kecorr
         input(7)=1
         GO TO 7
c ..... Cosmological parameters: H_0, Omega_0, Omega_Lambda
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) h0
         INPUT(8)=1
         GO TO 7
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) om
         INPUT(9)=1
         GO TO 7
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) ov
         INPUT(10)=1
         GO TO 7
c ..... Formation redshift
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) z_form
         INPUT(11)=1
         GO TO 7
c ..... Redshift range and step
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) z_min
         INPUT(12)=1
         GO TO 7
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,*) z_max
         INPUT(13)=1
         GO TO 7
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,*) dz
         INPUT(14)=1
         GO TO 7
c ..... Lyman forest
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,*) lyf
         INPUT(15)=1
         GO TO 7
c ..... output file 
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,'(A)') spectra1
         input(16)=1
         GO TO 7
c ..... reddening
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) av
         INPUT(17)=1
         GO TO 7
      ELSE 
         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)
      DO i=1,nparam
         IF (input(i).eq.0) THEN
            WRITE(*,*) 'Missed parameter ', param(i)
            STOP
         END IF
      END DO

      OPEN(10,FILE=file_def,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      last=INDEX(line_sed,' ')-1
      NAMECH(iii)=line_sed(1:last)
      line_sed=line_sed(last+1:)
      DO i=1,80
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', NAMECH(iii)
      STOP
 2221 sed_abc(iii)=line_sed(1:2)
      iii=iii+1
      GO TO 2230
 2220 n_files=iii-1
      WRITE(*,*) 'There are ',n_files,' synthetic spectra'
      CLOSE(10)

      WRITE(*,*) 'Reading synthetic spectra :'
      DO i=1,n_files
         WRITE(*,2005) i, NAMECH(i)(1:lnblnk(namech(i)))
c binary GISSEL's templates
         IF (sed_abc(i).eq.'BC') THEN
            OPEN(1,FILE=NAMECH(i),STATUS='old',
     .           FORM='unformatted',ERR=25)
            READ (1) ks(i),(t_bc0(ii),ii=1,ks(i)) ! KS = n. temporal intervals
            READ (1) iw(i),(w_bc(ii,i),ii=1,iw(i)) !Number of wavelengths
            DO j=1,ks(i)
               t_bc(j)=DBLE(t_bc0(j))
               READ (1) iw(i),(f_bc(ii,j,i),ii=1,iw(i))
            ENDDO
            CLOSE(1)
c ASCII templates
         ELSE IF (sed_abc(i).eq.'A '.or.sed_abc(i).eq.'AS')THEN
            OPEN(1,FILE=NAMECH(i),STATUS='old',
     .           FORM='formatted',ERR=25)
            ii=1
 33         READ(1,*,ERR=34,END=34) w_as(ii,i),f_as(ii,i)
            ii=ii+1
            GO TO 33
 34         iw(i)=ii-1
            CLOSE(1)
         ELSE
            WRITE(*,*) 'Don''t know how to read :'
            WRITE(*,'(A)') NAMECH(i)
            STOP
         END IF
      END DO
 2005 FORMAT(' Type ', I2, ' : ', A)


c ..... Reading filt_file 
      CALL filter0
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)
      i=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      i=i+1
      write(*,'(i2,a78)') i,line
      ncomp=1
      DO k=1,80
         IF (line(k:k).eq.'&') THEN
            line(k:k)=' '
            ncomp=ncomp+1
         ELSE IF (line(k:k).eq.'#') THEN
            GO TO 136 
         END IF
      END DO
 136  CONTINUE
c ..... simple filter
      IF (ncomp.eq.1) THEN
         READ(line,*) nfil(i)
         IF (nfil(i).gt.icomp) THEN
            WRITE(*,1998) nfil(i),icomp
            STOP
         ELSE
            kfil(1)=nfil(i)
            CALL compos_new(1,kfil,wl(i),surf(i),bp1)
            GO TO 134
         END IF
c ..... composite filter
      ELSE 
         READ(line,*) (kfil(j),j=1,ncomp)
         icomp=icomp+1
         nfil(i)=icomp
         CALL compos_new(ncomp,kfil,wl(i),surf(i),bp1)
         GO TO 134
      END IF
 1998 FORMAT('Filter number ',I4, ' out of range!',/,
     .       'Maximum = ',I4)
 135  n_filter=i
      WRITE(*,*) 'There are ',n_filter,' filters'
      CLOSE(10)

      WRITE(fmt,1002) n_filter
 1002 FORMAT('(1x,f8.4,1x,i3,',i2,'(1x,f7.3),1x,f12.3,1x,f12.4,
     &     1x,f12.4))')

c.................................................

      OPEN(14,file=spectra1,status='unknown')
      DO iii=1,n_files
         WRITE(14,'(a,1x,i2,1x,a)') '# ',iii,
     &        namech(iii)(1:lnblnk(namech(iii)))
      END DO

      WRITE (*,'(1x,a)') 'Reading reference sed:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(1x,a)') line (1:78)
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)*scl
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,*) 'There are ',iw_vega,' points in Vega'
      jread=iw_vega

c computing correction AB-Vega magnitudes
c AB=Vega+abconv

      z0=0.D0
      WRITE(*,'(a)')
     .     '#  n     wl_eff    surface  conv_AB=AB-Vega'
c ..... Conversion from AB to standard magnitudes
c compute f_Vega(nu)
      DO i=1,iw_vega
         fnu_vega(i)=f_vega(i)*w_vega(i)*w_vega(i)/c
         rnu_vega(i)=c/w_vega(i)
      END DO
      DO k=1,n_filter
         vega(k)=filter(nfil(k),w_vega,f_vega,iw_vega,z0)
c transmission function R(nu): R(nu) d(nu)= R(lambda) d(lambda)
         DO i=1,np(nfil(k))
            wrnu(i)=c/r(i,nfil(k),1) ! frequency
            rrnu(i)=r(i,nfil(k),2) ! R(nu)
         END DO
c R(nu)*f_vega(nu)
         DO i=1,np(nfil(k))
            l=0
            ffnu(i)=rrnu(i)*rlin(wrnu(i),rnu_vega,fnu_vega,iw_vega,l)
         END DO
c integrals with trapezoids
         ff1=trapz1(wrnu,ffnu,np(nfil(k)))
         ff2=trapz1(wrnu,rrnu,np(nfil(k)))
         abconv(k)=-2.5D0*DLOG10(ff1/ff2)-48.60D0
      END DO

      DO k=1,n_filter
         WRITE(*,1999) nfil(k),wl(k),surf(k),abconv(k)
      END DO
 1999 FORMAT(2X,I3,1X,F9.2,1X,F10.3,1X,F7.3,1X,F7.3,1X,F7.3)

      IF (mag_typ.eq.0) THEN ! Vega mag, no need correction
         DO k=1,n_filter
            abconv(k)=0.D0
         END DO
      END IF

      nz=INT((z_max-z_min)/dz)+1
      age_form=tz(h0,om,ov,z_form) ! age of universe at z_form
      age_uni=tz(h0,om,ov,z0)-age_form ! age of a galaxy at z=0
      WRITE(*,*) 'Age of a galaxy at z = 0: Age = ',age_uni, ' Gyr'

      z=0.D0
      age_z=tz(h0,om,ov,z)      ! age of universe at z [Gyr]
      dl=d_l(h0,om,ov,z)        ! luminosity distance
      DO ityp=1,n_files
         IF (sed_abc(ityp).eq.'BC') THEN
            IF (kecorr.eq.0) THEN ! k-corr only
               age=age_uni
               DO k=1,ks(ityp)-1
                  IF (age_uni.ge.t_bc(k)*1.D-9.and.
     .                 age_uni.lt.t_bc(k+1)*1.D-9) THEN
                     i1=k
                     i2=k+1
                     GO TO 37
                  END IF
               END DO
 37            DO l=i1,i2
                  DO i=1,iw(ityp) !lambda
                     f(i,l)=DBLE(f_bc(i,l,ityp))
                     ww(i)=DBLE(w_bc(i,ityp))
                     IF (lyf.eq.1.or.lyf.eq.2) THEN
                        IF (ww(i).lt.912.0D0) f(i,l)=0.0D0
                     END IF
                  END DO
               END DO
               tx=age_uni
               t1=t_bc(i1)*1.D-9
               t2=t_bc(i2)*1.D-9
               a1=(t2-tx)/(t2-t1)
               a2=1.-a1
               DO i=1,iw(ityp)
                  y(i)=a1*f(i,i1)+a2*f(i,i2)
               END DO
            ELSE                ! k and evolutionary corrections
               age=age_z-age_form
               DO k=1,ks(ityp)-1
                  IF (age.ge.t_bc(k)*1.D-9.and.
     .                 age.lt.t_bc(k+1)*1.D-9) THEN
                     i1=k
                     i2=k+1
                     GO TO 38
                  END IF
               END DO
 38            DO l=i1,i2
                  DO i=1,iw(ityp) !lambda
                     f(i,l)=DBLE(f_bc(i,l,ityp))
                     ww(i)=DBLE(w_bc(i,ityp))
                     IF (lyf.eq.1.or.lyf.eq.2) THEN
                        IF (ww(i).lt.912.0D0) f(i,l)=0.0D0
                     END IF
                  END DO
               END DO
               tx=age
               t1=t_bc(i1)*1.D-9
               t2=t_bc(i2)*1.D-9
               a1=(t2-tx)/(t2-t1)
               a2=1.D0-a1
               DO i=1,iw(ityp)
                  y(i)=a1*f(i,i1)+a2*f(i,i2)
               END DO
            END IF
         ELSE
            DO i=1,iw(ityp)
               y(i)=DBLE(f_as(i,ityp))
               ww(i)=DBLE(w_as(i,ityp))
               IF (lyf.eq.1.or.lyf.eq.2) THEN
                  IF (ww(i).lt.912.0D0) y(i)=0.0D0
               END IF
            END DO
         END IF
         IF (av.gt.0.0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(ityp),law_rd)
            DO k=1,iw(ityp)
               y(k)=yob(k)
            END DO
         END IF

         DO k=1,n_filter
            flux=filter(nfil(k),ww,y,iw(ityp),z)
            fluxz0=filter(nfil(k),ww,y,iw(ityp),z0)
            IF (flux.gt.1.D-100) THEN
               amag(k)=-2.5D0*DLOG10(flux/(vega(k)*dl*dl*factmass))
               IF (mag_frame.eq.1) THEN
                  amabs(k)=-5.D0*DLOG10(dl)-25.D0
     .                 -2.5D0*DLOG10(fluxz0/vega(k))
               END IF
               IF (mag_typ.eq.1) THEN
                  amag(k)=amag(k)+abconv(k)
                  IF (mag_frame.eq.1) THEN
                     amabs(k)=amabs(k)+abconv(k)
                  END IF
               END IF
            ELSE
               amag(k)=200.D0
               amabs(k)=200.D0
            END IF
         END DO
         DO k=1,n_filter
            IF (amag(k).gt.100.D0) amag(k)=99.D0
            IF (amabs(k).gt.100.D0) amabs(k)=99.D0
         END DO

         IF (mag_frame.eq.1) THEN
            WRITE(14,fmt) z,ityp,(amabs(k),k=1,n_filter),dl,age_z,age
         ELSE
            WRITE(14,fmt) z,ityp,(amag(k),k=1,n_filter),dl,age_z,age
         END IF
      END DO

      DO iz=1,nz
         z=z_min+(iz-0.5D0)*dz
         age_z=tz(h0,om,ov,z)   ! age of universe at z [Gyr]
         dl=d_l(h0,om,ov,z)     ! luminosity distance
         DO ityp=1,n_files
            IF (sed_abc(ityp).eq.'BC') THEN
               IF (kecorr.eq.0) THEN ! k-corr only
                  age=age_uni
                  DO k=1,ks(ityp)-1
                     IF (age_uni.ge.t_bc(k)*1.D-9.and.
     .                    age_uni.lt.t_bc(k+1)*1.D-9) THEN
                        i1=k
                        i2=k+1
                        GO TO 22
                     END IF
                  END DO
 22               DO l=i1,i2
                     DO i=1,iw(ityp) !lambda
                        f(i,l)=DBLE(f_bc(i,l,ityp))
                        ww(i)=DBLE(w_bc(i,ityp))
                        IF (lyf.eq.1.or.lyf.eq.2) THEN
                           IF (ww(i).lt.912.0D0) f(i,l)=0.0D0
                        END IF
                     END DO
                  END DO
                  tx=age_uni
                  t1=t_bc(i1)*1.D-9
                  t2=t_bc(i2)*1.D-9
                  a1=(t2-tx)/(t2-t1)
                  a2=1.-a1
                  DO i=1,iw(ityp)
                     y(i)=a1*f(i,i1)+a2*f(i,i2)
                  END DO
               ELSE             ! k and evolutionary corrections
                  age=age_z-age_form
                  DO k=1,ks(ityp)-1
                     IF (age.ge.t_bc(k)*1.D-9.and.
     .                    age.lt.t_bc(k+1)*1.D-9) THEN
                        i1=k
                        i2=k+1
                        GO TO 24
                     END IF
                  END DO
 24               DO l=i1,i2
                     DO i=1,iw(ityp) !lambda
                        f(i,l)=f_bc(i,l,ityp)
                        ww(i)=w_bc(i,ityp)
                        IF (lyf.eq.1.or.lyf.eq.2) THEN
                           IF (ww(i).lt.912.0D0) f(i,l)=0.0D0
                        END IF
                     END DO
                  END DO
                  tx=age
c                  write(*,*) z,age
                  t1=t_bc(i1)*1.D-9
                  t2=t_bc(i2)*1.D-9
                  a1=(t2-tx)/(t2-t1)
                  a2=1.-a1
                  DO i=1,iw(ityp)
                     y(i)=a1*f(i,i1)+a2*f(i,i2)
                  END DO
               END IF
            ELSE
               DO i=1,iw(ityp)
                  y(i)=DBLE(f_as(i,ityp))
                  ww(i)=DBLE(w_as(i,ityp))
                  IF (lyf.eq.1.or.lyf.eq.2) THEN
                     IF (ww(i).lt.912.0D0) y(i)=0.0D0
                  END IF
               END DO
            END IF

            IF (av.gt.0.0) THEN
               CALL red_spec(ww,y,av,yob,1,iw(ityp),law_rd)
               DO k=1,iw(ityp)
                  y(k)=yob(k)
               END DO
            END IF
            IF (lyf.eq.1) THEN
               CALL lyman_forest(ww,y,iw(ityp),z)
            END IF

            DO k=1,n_filter
               flux=filter(nfil(k),ww,y,iw(ityp),z)
              IF (flux.gt.1.D-100) THEN
                  amag(k)=-2.5D0*DLOG10(flux/(vega(k)*dl*dl*factmass))
                  IF (mag_frame.eq.1) THEN
                     fluxz0=filter(nfil(k),ww,y,iw(ityp),z0)
                     amabs(k)=-5.D0*DLOG10(dl)-25.D0
     .                    -2.5D0*DLOG10(fluxz0/vega(k))
                  END IF
                  IF (mag_typ.eq.1) THEN
                     amag(k)=amag(k)+abconv(k)
                     IF (mag_frame.eq.1) THEN
                        amabs(k)=amabs(k)+abconv(k)
                     END IF
                  END IF
               ELSE
                  amag(k)=200.D0
                  amabs(k)=200.D0
               END IF
            END DO
            DO k=1,n_filter
               IF (amag(k).gt.100.D0) amag(k)=99.D0
               IF (amabs(k).gt.100.D0) amabs(k)=99.D0
            END DO

c absolute magnitude
            IF (mag_frame.eq.1) THEN
               WRITE(14,fmt) z,ityp,(amabs(k),k=1,n_filter),dl,age_z,age
            ELSE
               WRITE(14,fmt) z,ityp,(amag(k),k=1,n_filter),dl,age_z,age
            END IF
         END DO
      END DO
      CLOSE(14)

      STOP
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening templates file'
 80   STOP 'Error reading filters'' file'
 3    STOP 'Program exits because of error reading A0 V s.e.d. file'
      END

c............................................................
c ..... Luminosity distance [Mpc]
 
      FUNCTION d_l(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 h0,om,ov,z,za,c,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.9979D+5,nstep=100)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
      IF (za.lt.1.D-5) THEN
         z=1.D-5
      ELSE
         z=za
      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_l=c/h0*d_l ! luminosity distance in Mpc
      RETURN
      END
