      PROGRAM make_catalog_mass
c     Version: 27/11/2007
c N.B. only BC models are supported. 
c in the spectra.param file the tau[Gyr]  must be specified for each SED:
c write 0. for SSP and a number <0 for constant star formation
c Needs to read files .4color: they must be located in same directory 
c of spectra. In *.4color files the interesting columns are 
c 1.log-age-yr, 7.M*, 8.Mgas, 9.Mgalaxy, 10.SFR/yr
c we are interested in M*, because we take into account the return fraction
      IMPLICIT NONE
      INTEGER mxwl,mxft,mxwf,mxfil,mxage,mxtyp,input,nparam,ilim,
     .     iseed,nemline,i,ii,iii,j,l,k,kk,ityp,kfil,icomp,nfil,
     .     iblank,inoise,ks,iread,iw,i_ob,jread,last,law_rd,nob,mxobj,
     .     nnn,nf,np,magtyp,ncomp,n_filter,n_files,i1,i2,i_age,iw_vega,
     .     ispectra1,ispectra2,ilyf,nlyf,mxlyf,mxz,mxred,nagelog,iext,
     .     jage1,jage2
      REAL*8 yz,yob,amag,av,avmax,avmin,averr,bmag,bmag_tmp,bp1,dif,
     .     z_int,err_p,rangauss,ran1,f1,f2,h0,om,ov,r,sig,surf,tz,
     .     t_bc,wl,w_vega,f_vega,f_tmp,fl,fl_jy,z,vega,age,age_z,
     .     age_form,zmax,zmin,z_form,filter,t1,t2,tx,a1,a2,diff_mag,
     .     ww,am_min,am_max,amag_ref,zero,am1,am2,am_err,sn0,am0,sn,
     .     f_sn,sn_0,am_0,amlimit,err_min,conv_mag,fnu_vega,rnu_vega,
     .     wrnu,rrnu,rrnu2,ffnu,trapz1,z0,c,rlin,r_lyf,fact_lyf,aa,bb,
     .     fl1,fl2,wlmin,wlmax,am,er,fler,tau,pi4,dl,d_l,starmass,
     .     galmass,sfrgal,flux,flux0,amag_ref0,b,amabs,factmass,fluxz0,
     .     fluxz,amag_ref0rf,b0,bmag0rf,stot,tot,scl,vegabol,sun,rnorm,
     .     wrnuf,rrnuf,flnu,yynu,wwnu,f2b,flnu_norm,amstar_tmp
      REAL w_bc,time_tot,t_bc0,f_bc,agelog,amstar,amgas,amgal,sfr,wv,fv
      PARAMETER (mxage=225)
      INCLUDE 'dimensionmass.dec'
      PARAMETER (nparam=24,mxobj=100000,am1=10.D0,am2=40.D0,
     .     am_err=1.D-8,pi4=3.141592654D0*4.D0)
      CHARACTER namech(mxtyp)*160,file4color(mxtyp)*160,line*240,
     .     sed_abc(mxtyp)*2,sed_tau(mxtyp)*12,cfilt(mxfil)*3,lineh*500
      CHARACTER*160 spectra,spectra1,spectra2,outfile,filedef,filein,
     .     spec_vega,filtresfile,filt_file,fmt,fmt2,fmtjy,fmt2jy,
     .     line_sed,copyright1,copyright2,date*24,vv*5
      CHARACTER*40 cname,param(nparam)
      INCLUDE 'filter.dec'

      DIMENSION input(nparam)
      DIMENSION ks(mxtyp),iw(mxtyp),tau(mxtyp),t_bc0(mxage)
      DIMENSION w_bc(mxwl,mxtyp),f_bc(mxwl,mxage,mxtyp),t_bc(mxage)
      DIMENSION fl1(mxwl),fl2(mxwl),ww(mxwl),yz(mxwl),yob(mxwl)
      DIMENSION nfil(0:mxfil),amabs(0:mxfil),f2(0:mxfil),f2b(0:mxfil)
      DIMENSION amag(mxfil),amlimit(mxfil),fl_jy(mxfil)
      DIMENSION err_p(mxfil),kfil(10),sn0(mxfil),am0(mxfil)
      DIMENSION w_vega(5000),f_vega(5000),f_tmp(5000),vega(0:mxfil)
      DIMENSION wl(0:mxfil),surf(0:mxfil),conv_mag(0:mxfil)
      DIMENSION fnu_vega(4000),rnu_vega(4000),yynu(mxwl),wwnu(mxwl)
      DIMENSION wrnu(mxwf),rrnu(mxwf),rrnu2(mxwf),ffnu(mxwf)
      DIMENSION wrnuf(mxwf,0:mxfil),rrnuf(mxwf,0:mxfil),flnu(mxwf)
      DIMENSION agelog(mxtyp,mxage),amstar(mxtyp,mxage),
     .     amgas(mxtyp,mxage),amgal(mxtyp,mxage),sfr(mxtyp,mxage)

      COMMON /compose/ icomp
      COMMON /namefile/ spec_vega
      COMMON /filterres/ filtresfile
      COMMON /s2n/sn_0,am_0
      COMMON /lyf_sigma/fact_lyf
      EXTERNAL ran1,rangauss,filter,tz,zero,f_sn,trapz1,rlin,d_l
c_________________________________________________________________________

      vv='2.0'
      copyright1=
     .     '  make_mass - synthetic catalogue code - Version '//vv
     .     //' (November 28, 2007)' 
      copyright2=' by Micol Bolzonella'
      WRITE(*,*)
      WRITE(*,'(a80)') copyright1
      WRITE(*,*)
      WRITE(*,'(a80)') copyright2
      WRITE(*,*)

      jread=0                   !Control on reading A0VSED
      iread=0                   !Control on reading Filter Library
      c=2.9979D+18              ! speed of light in AA/s
      factmass=pi4*3.085678D0*3.085678D48/3.826D33
      nlyf=1                    ! considering only the mean Madau value
      r_lyf=1.D0
      fact_lyf=1.D0
      flnu_norm=1.E-30

c ..... Parameters in common hyperz & make_catalog
      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='FILTERS_FILE'
      param(4)='TEMPLATES_FILE'
      param(5)='MAG_TYPE'
      param(6)='ERR_MAG_MIN'
      param(7)='Z_MIN'
      param(8)='Z_MAX'
      param(9)='REDDENING_LAW'
      param(10)='AV_MIN'
      param(11)='AV_MAX'
      param(12)='LY_FOREST'
      param(13)='OUTPUT_FILE'
      param(14)='H0'
      param(15)='OMEGA_M'
      param(16)='OMEGA_V'
c ..... Parameters relative to make_catalog only
      param(17)='REF_FILTER'
      param(18)='MAG_MIN'
      param(19)='MAG_MAX'
      param(20)='NOISE_TYPE'
      param(21)='N_OBJ'
      param(22)='Z_FORM'
      param(23)='AGE_RANDOM'
      param(24)='RAND_SEED'
      DO i=1,nparam
         input(i)=0
      END DO

 44   filein='hyp_makezmass.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file' 
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ (*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)') filein
      END IF

      OPEN(77,FILE=filein,STATUS='old',ERR=44)
 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c Parameters in common hyperz & make_catalog
c ..... A0VSED file
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c .... FILTER file
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing filters and noise sigma
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') filt_file
         input(3)=1
         GO TO 7
c ..... File containing synthetic spectra filenames
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filedef
         input(4)=1
         GO TO 7
c ..... Magnitude type:
c       0 -> standard magnitudes
c       1 -> AB magnitudes
c       2 -> Flux in microJansky 
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) magtyp
         IF (magtyp.ne.0.and.magtyp.ne.1.and.magtyp.ne.2) THEN
            WRITE(*,*) 'MAG_TYPE must be 0 , 1 or 2'
            STOP
         END IF
         input(5)=1
         GO TO 7
c ..... Minimum photometric error (if NOISE_TYPE = 1)
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) err_min
         INPUT(6)=1
         GO TO 7
c ..... Redshift range
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) zmin
         INPUT(7)=1
         GO TO 7
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) zmax
         INPUT(8)=1
         GO TO 7
c ..... Reddening:
c       0 -> No reddening
c       1 -> Allen, 1976, standard MW
c       2 -> Seaton, 1979, standard MW
c       3 -> Fitzpatrick, 1986, LMC
c       4 -> Prevot, 1984, + Bouchet, 1985, SMC 
c       5 -> Calzetti et al., 2000
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) law_rd
         IF (law_rd.ne.0.and.law_rd.ne.1.and.law_rd.ne.2.and.
     .        law_rd.ne.3.and.law_rd.ne.4.and.law_rd.ne.5) THEN
            WRITE(*,*) 'REDDENING_LAW must be 0 -- 5'
            STOP
         END IF
         input(9)=1
         GO TO 7
c ..... Av_max, Av_min
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) avmin
         input(10)=1
         GO TO 7
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) avmax
         input(11)=1
         GO TO 7
c .... Lyman Forest
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) r_lyf
         IF (r_lyf.lt.1.D-4) r_lyf=1.D0
         IF (r_lyf.lt.1.D0) r_lyf=1.D0/r_lyf
         IF (ABS(r_lyf-1.D0).lt.1.D-4) THEN
            nlyf=1 ! considering only the mean Madau value
         ELSE
            nlyf=3 ! considering 3 values: mean Madau value + 2 values 
         END IF
         input(12)=1
         GO TO 7
c ..... Output files: no extension (file = *)
c       *.model -> model catalogue
c       *.cat   -> catalogue with noise
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,'(A)') spectra
         iblank=INDEX(spectra,' ')
         spectra1=spectra(1:iblank-1)//'.model'
         spectra2=spectra(1:iblank-1)//'.cat'
         outfile=spectra(1:iblank-1)//'.out_cat'
         input(13)=1
         GO TO 7
c ..... Cosmological parameters: H_0, Omega_matter, Omega_lambda
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,*) h0
         INPUT(14)=1
         GO TO 7
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,*) om
         INPUT(15)=1
         GO TO 7
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,*) ov
         INPUT(16)=1
         GO TO 7
c Parameters relative to make_catalog only
c ..... Reference filter 
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) nfil(0)
         input(17)=1
         GO TO 7
c ..... Minimum magnitude in reference filter
      ELSE IF (cname.eq.param(18)) THEN
         READ(line,*) am_min
         input(18)=1
         GO TO 7
c ..... Maximum magnitude in reference filter
      ELSE IF (cname.eq.param(19)) THEN
         READ(line,*) am_max
         input(19)=1
         GO TO 7
c ..... Type of noise:
c       0. random with fixed sigma in magnitudes
c       1. with dm(m)
      ELSE IF (cname.eq.param(20)) THEN
         READ(line,*) inoise
         IF (inoise.ne.0.and.inoise.ne.1) THEN
            WRITE(*,*) 'NOISE_TYPE must be 0 or 1'
            STOP
         END IF
         INPUT(20)=1
         GO TO 7
c ..... Number of objects
      ELSE IF (cname.eq.param(21)) THEN
         READ(line,*) nob
         IF (nob.gt.mxobj) THEN
            WRITE(*,'(1x,a,i7,a)') 
     .           'Number of objects exceeding the maximum [max=',
     .           mxobj,']'
            STOP
         END IF
         INPUT(21)=1
         GO TO 7
c ..... Formation redshift
      ELSE IF (cname.eq.param(22)) THEN
         READ(line,*) z_form
         INPUT(22)=1
         GO TO 7
c ..... Age: choice for galaxy age
c       0. age = age of universe T(z_form)
c       1. age = random between 0 and T(z)-T(z_form)
      ELSE IF (cname.eq.param(23)) THEN
         READ(line,*) i_age
         IF (i_age.ne.0.and.i_age.ne.1) THEN
            WRITE(*,*) 'AGE_RANDOM must be 0 or 1'
            STOP
         END IF
         INPUT(23)=1
         GO TO 7
c ..... Seed for random generator
      ELSE IF (cname.eq.param(24)) THEN
         READ(line,*) iseed
         input(24)=1
         GO TO 7
c Parameters changed from version 1.1 to 1.2
      ELSE IF (cname.eq.'MODEL_CAT_FILE') THEN
         READ(line,'(A)') spectra1
         ispectra1=1
         GO TO 7
      ELSE IF (cname.eq.'NOISE_CAT_FILE') THEN
         READ(line,'(A)') spectra2
         ispectra2=1
         GO TO 7
      ELSE 
c         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF
 10   CONTINUE
      CLOSE(77)
      DO i=1,nparam
         IF (input(i).eq.0.and.i.ne.12.and.i.ne.13.and.i.ne.5) THEN 
            WRITE(*,*) 'Missed parameter ', param(i)
            STOP
         END IF
      END DO
      IF (input(5).eq.0) magtyp=0 ! Default Vega magnitudes
      IF (input(13).eq.0) THEN
         IF (ispectra1.eq.1.and.ispectra2.eq.1) THEN
            iblank=INDEX(spectra2,'.')
            outfile=spectra2(1:iblank-1)//'.out_cat'
         ELSE
            WRITE(*,*) 'Missed parameter ', param(13)
         END IF
      END IF
      IF (input(12).eq.0) THEN
         r_lyf=1.D0
         nlyf=1
      END IF
      IF (law_rd.eq.0) THEN
         avmin=0.0D0
         avmax=0.0D0
      END IF
      IF (zmax.gt.z_form) zmax=z_form
      IF (am_min.le.0..and.am_max.le.0..and.am_min.le.am_max) THEN
         ilim=1
      ELSE IF (am_min.ge.0..and.am_max.ge.0..and.am_min.le.am_max) THEN
         ilim=0
      ELSE
         WRITE(*,*) 
     .        'STOP: MAG_MIN and MAG_MAX are not in the correct order'
         STOP
      END IF

c ..... Reading filt_file (format depending on noise type)

      CALL filter0
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)
      i=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      i=i+1
      ncomp=1
      DO k=1,80
         IF (line(k:k).eq.'&') THEN
            line(k:k)=' '
            ncomp=ncomp+1
         ELSE IF (line(k:k).eq.'#') THEN
            GO TO 136
         END IF
      END DO
 136  CONTINUE
c ..... simple filter
      IF (ncomp.eq.1) THEN
         IF (inoise.eq.0) THEN
            READ(line,*,ERR=82) nfil(i), err_p(i)
            IF (nfil(i).gt.icomp) THEN
               WRITE(*,1998) nfil(i),icomp
               STOP
            ELSE
               kfil(1)=nfil(i)
               CALL compos_new(1,kfil,wl(i),surf(i),bp1)
               GO TO 134
            END IF
         ELSE IF (inoise.eq.1) THEN
            READ(line,*,ERR=81) nfil(i), sn0(i), am0(i)
            IF (sn0(i).eq.0.) THEN
               WRITE(*,*) 'Reference S/N must be > 0'
               STOP
            END IF
            IF (nfil(i).gt.icomp) THEN
               WRITE(*,1998) nfil(i),icomp
               STOP
            ELSE
               kfil(1)=nfil(i)
               CALL compos_new(1,kfil,wl(i),surf(i),bp1)
               GO TO 134
            END IF
         END IF 
c ..... composite filter
      ELSE 
         IF (inoise.eq.0) THEN
            READ(line,*,ERR=82) (kfil(j),j=1,ncomp), err_p(i)
            icomp=icomp+1
            nfil(i)=icomp
            CALL compos_new(ncomp,kfil,wl(i),surf(i),bp1)
            GO TO 134
         ELSE IF (inoise.eq.1) THEN
            READ(line,*,ERR=81) (kfil(j),j=1,ncomp), sn0(i), am0(i)
            IF (sn0(i).lt.1.E-8) THEN
               WRITE(*,*) 'Reference S/N must be > 0'
               STOP
            END IF
            icomp=icomp+1
            nfil(i)=icomp
            CALL compos_new(ncomp,kfil,wl(i),surf(i),bp1)
            GO TO 134
         END IF 
      END IF
 1998 FORMAT('Filter number ',I4, ' out of range!',/,
     .       'Maximum = ',I4)
 135  n_filter=i
      IF (n_filter.gt.mxfil) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of filters exceeding the maximum [max=',mxfil,']'
         STOP
      END IF
      WRITE(*,*) 'There are ',n_filter,' filters'
      CLOSE(10)
c ..... Reference filter
      kfil(1)=nfil(0)
      CALL compos_new(1,kfil,wl(0),surf(0),bp1)

c maximum and minimum wavelength in filters
      wlmax=0.D0
      wlmin=1.D8
      DO i=1,n_filter
         wlmax=MAX(wlmax,r(np(i),i,1))
         wlmin=MIN(wlmin,r(1,i,1))
      END DO
c maximum wavelength at the maximum redshift
      wlmax=wlmax*(1.D0+zmax)
c minimum wavelength at the minimum redshift
      wlmin=wlmin*(1.D0+zmin)

c ..... reading the names of SEDs

      OPEN(10,FILE=filedef,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            last=INDEX(line_sed,' ')-1
            namech(iii)=line_sed(1:last)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed name SED files '
      STOP
 2221 line_sed=line_sed(last+1:)
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            sed_abc(iii)=line_sed(1:2)
            IF (sed_abc(iii).ne.'BC') THEN
               last=INDEX(namech(iii),' ')
               WRITE(*,'(a)') 'The type of SED '//namech(iii)(1:last)//
     .              ' is '//sed_abc(iii)
               WRITE(*,'(a)') 'Only BC type is supported'
               STOP
            END IF
            last=INDEX(line_sed,' ')-1
            GO TO 2222
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', namech(iii)
      STOP
 2222 line_sed=line_sed(last+1:)
      DO i=1,160
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            last=INDEX(line_sed,' ')-1
            sed_tau(iii)=line_sed(1:last)
            GO TO 2223
         END IF
      END DO
      WRITE(*,*) 'Missed tau of SFR for file', namech(iii)
      STOP
 2223 read(sed_tau(iii),*) tau(iii)
      iii=iii+1
      GO TO 2230
 2220 n_files=iii-1
      IF (n_files.gt.mxtyp) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of files exceeding the maximum [max=',mxtyp,']'
         STOP
      END IF
      WRITE(*,*) 'There are ',n_files,' synthetic spectra'
      CLOSE(10)

c ..... Reading the SEDs

      WRITE(*,*) 'Reading synthetic spectra :'
      DO i=1,n_files
         last=INDEX(namech(i),' ')
         WRITE(*,2005) i,namech(i)(1:last)
c BC templates only
         OPEN(1,FILE=namech(i),STATUS='old',
     .        FORM='unformatted',ERR=25)
         READ (1) ks(i),(t_bc0(ii),ii=1,ks(i)) ! ks = n. temporal intervals
         READ (1) iw(i),(w_bc(ii,i),ii=1,iw(i)) ! Number of wavelengths
         IF (iw(i).gt.mxwl) THEN
            WRITE(*,'(a,i6)') 'Number of wavelengths in GISSEL '
     .           //'templates exceeding the maximum. Max = ',mxwl
            WRITE(*,'(a)') 
     .           ' Reduce BC wavelenghts or modify mxwl in '
     .           //'dimensionmass.dec and recompile'
            STOP
         END IF
         
         DO j=1,ks(i)
            t_bc(j)=DBLE(t_bc0(j))
            READ (1) iw(i),(f_bc(ii,j,i),ii=1,iw(i))
            DO ii=1,iw(i)
               IF (w_bc(ii,i).lt.912.) f_bc(ii,j,i)=0.D0
            END DO
         END DO
         CLOSE(1)
      END DO
 2005 FORMAT(' Type ', I2, ' : ', A)

      WRITE(*,*) 'Reading *.4color files :'
      DO i=1,n_files
         iext=INDEX(namech(i),'.ised')-1
         file4color(i)=namech(i)(1:iext)//'.4color'
         WRITE(*,'(a)') file4color(i)(1:iext+7)
c impose values for record age=0 present in ised files and not in 4color
         j=1
         agelog(i,j)=-99.
         amstar(i,j)=1.
         amgas(i,j)=0.
         amgal(i,j)=1.
         sfr(i,j)=0.
         OPEN(20,FILE=file4color(i),STATUS='old',ERR=26)
 2224    READ(20,'(a)',ERR=2225,END=2225) line
         IF(line.eq.' '.or.line(1:1).eq.'#') GO TO 2224
         j=j+1
         READ(line,*) agelog(i,j),aa,aa,aa,aa,aa,amstar(i,j),
     .        amgas(i,j),amgal(i,j),sfr(i,j)
         GO TO 2224
 2225    CLOSE(20)
         nagelog=j
      END DO

c ..... Reading Vega spectrum

      WRITE (*,'(1x,a)') 'Reading reference sed:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(1x,a)') line (1:78)

      scl=2.D-17
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)*scl
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,*) 'There are ',iw_vega,' points in Vega'
      jread=iw_vega

c -----------------------------------------------------------------------
c                    Filters and .out_cat file
c -----------------------------------------------------------------------

      OPEN(18,FILE=outfile,STATUS='unknown')
      WRITE(18,'(a)')
     .     '##########################################################'
      WRITE(18,'(a,1x,a)')
     .     '# This is the output file of make_catmass - Version '//vv
      WRITE(18,'(a)')
     .     '##########################################################'
      CALL fdate(date)
c      CALL fdate_(date)   ! IBM
      WRITE(18,'(a)') '# Date: '//date
      WRITE(18,'(a)') '# Output catalogues : '
      last=INDEX(spectra1,' ')-1
      WRITE(18,'(2x,a)')  spectra1(1:last)
      last=INDEX(spectra2,' ')-1
      WRITE(18,'(2x,a)')  spectra2(1:last)
      WRITE(18,'(a)') 
     .     '# Templates SEDs:'
      DO i=1,n_files
         last=INDEX(namech(i),' ')-1
         WRITE(18,'(2x,i2,2x,a,2x,a,2x,f9.4)') i,namech(i)(1:last),
     .     sed_abc(i),tau(i)
      END DO
      WRITE(18,'(a)') '# Characteristics of filters'

      IF (inoise.eq.1) THEN
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
c ..... Computing limiting magnitudes
            DO kk=1,n_filter
               sn_0=sn0(kk)
               am_0=am0(kk)
               amlimit(kk)=zero(f_sn,am1,am2,am_err)
            END DO
         ELSE IF (magtyp.eq.2) THEN
            DO kk=1,n_filter
               amlimit(kk)=am0(kk)/sn0(kk)
            END DO
         END IF
      END IF

      IF (inoise.eq.1) THEN
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN 
            WRITE(*,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB  mag_lim'
            WRITE(18,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB  mag_lim'
         ELSE IF (magtyp.eq.2) THEN
            WRITE(*,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB    flux_lim'
            WRITE(18,'(a)') 
     .           '#  n       wl_eff       surface   conv_AB    flux_lim'
         END IF
      ELSE
         WRITE(*,'(a)') 
     .        '#  n       wl_eff       surface   conv_AB'
         WRITE(18,'(a)') 
     .        '#  n       wl_eff       surface   conv_AB'
      END IF
      z0=0.D0

c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
c compute f_Vega(nu)
      DO i=1,iw_vega
         fnu_vega(i)=f_vega(i)*w_vega(i)*w_vega(i)/c
         rnu_vega(i)=c/w_vega(i)
      END DO

      DO k=0,n_filter
         vega(k)=filter(nfil(k),w_vega,f_vega,iw_vega,z0)

c transmission function R(nu): R(nu) d(nu)= R(lambda) d(lambda)
         DO i=1,np(nfil(k))
            wrnu(i)=c/r(i,nfil(k),1) ! frequency
            rrnu(i)=r(i,nfil(k),2) ! R(nu)=R(lambda)
            wrnuf(i,k)=wrnu(i) ! frequency of filter k
            rrnuf(i,k)=rrnu(i) ! R(nu) of filter k
            rrnu2(i)=rrnu(i)*c/(wrnu(i)*wrnu(i)) ! R(nu)
         END DO
c R(nu)*f_vega(nu)
         DO i=1,np(nfil(k))
            l=0
            ffnu(i)=rrnu(i)*rlin(wrnu(i),rnu_vega,fnu_vega,iw_vega,l)
         END DO
c integrals with trapezoids
         f1=trapz1(wrnu,ffnu,np(nfil(k)))
         f2(k)=trapz1(wrnu,rrnu,np(nfil(k)))
         f2b(k)=trapz1(wrnu,rrnu2,np(nfil(k)))
         conv_mag(k)=-2.5D0*DLOG10(f1/f2(k))-48.60D0
c ..... Wavelength limit for the break in each filter 
c         aw_limit(k)=r(np(nfil(k))-1,nfil(k),1)
      END DO

      DO k=1,n_filter
         IF (inoise.eq.1) THEN
            IF (magtyp.eq.2) THEN
               WRITE(*,1996) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
               WRITE(18,1996) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
            ELSE IF(magtyp.eq.0.or.magtyp.eq.1) THEN
               WRITE(*,1997) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
               WRITE(18,1997) nfil(k),wl(k),surf(k),conv_mag(k),
     .              amlimit(k)
            END IF
         ELSE
            WRITE(*,1999) nfil(k),wl(k),surf(k),conv_mag(k)
            WRITE(18,1999) nfil(k),wl(k),surf(k),conv_mag(k)
         END IF
      END DO
 1997 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3,4X,F7.3)
 1996 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3,4X,E10.4)
 1999 FORMAT(2X,I3,1X,F12.3,1X,F12.3,2X,F7.3)

      nnn=2*n_filter+2
      WRITE(fmt,1002) nnn
      WRITE(fmtjy,1003) 2*n_filter
 1002 FORMAT('(1x,i12,1x,f7.3,1x,i3,1x,f7.3,',i2,'(1x,f7.3),2(1x,f12.5),
     &     1x,f12.5,1x,e12.5,1x,e11.4,1x,f9.4)')
 1003 FORMAT('(1x,i12,1x,f7.3,1x,i3,1x,f7.3,',i2,'(1x,e11.4),1x,f8.3,
     &     1x,f6.2,2(1x,f12.5),1x,f12.5,1x,e12.5,1x,e11.4,1x,f9.4)')
      WRITE(fmt2,2001) n_filter,n_filter
      WRITE(fmt2jy,2002) n_filter,n_filter
 2001 FORMAT('(1x,i6,',i2,'(1x,f7.3),',i2,'(1x,f6.3),1x,f7.3)')
 2002 FORMAT('(1x,i6,',i2,'(1x,e11.4),',i2,'(1x,e11.4),1x,f7.3)')

      WRITE(18,'(a)') '#    zmin      zmax'
      WRITE(18,'(4X,3(F5.2,5X))') zmin,zmax
      WRITE(18,'(a)') '#    AVmin     AVmax  red_law'
      WRITE(18,'(4X,2(F5.2,5X),I2)') avmin,avmax,law_rd
      WRITE(18,'(a)') 
     .     '#    Lyman_forest [factor(s) multiplying <tau_eff>]'
      IF (nlyf.eq.1) WRITE(18,'(4X,F6.3)') r_lyf
      IF (nlyf.eq.3) WRITE(18,'(4X,3(F6.3,2X))') 
     .     1.D0/r_lyf,r_lyf/r_lyf,r_lyf
      IF (magtyp.eq.0.or.magtyp.eq.1) WRITE(18,'(a)') 
     .     '#    magmin    magmax   ref_filter  mag type'
      IF (magtyp.eq.2) WRITE(18,'(a)') 
     .     '#    fluxmin     fluxmax    ref_filter  mag type'
      IF (magtyp.eq.0) WRITE(18,'(4X,2(F7.2,2X),4X,I3,8X,A)') 
     .     am_min,am_max,nfil(0),'Vega'
      IF (magtyp.eq.1) WRITE(18,'(4X,2(F7.2,2X),4X,I3,8X,A)') 
     .     am_min,am_max,nfil(0),'AB'
      IF (magtyp.eq.2) WRITE(18,'(5X,2(E10.4,2X),4X,I3,5X,A)') 
     .     am_min,am_max,nfil(0),'muJy'
      WRITE(18,'(a)') '#    Omega_0   Omega_v  H_0'
      WRITE(18,'(4X,3(F5.2,5X))') om,ov,h0
      WRITE(18,'(a)') '#    Seed for random generator'
      WRITE(18,'(4X,i20)') iseed

c ----- End of preliminaries

      age_form=tz(h0,om,ov,z_form) ! age of universe at z_form
      WRITE(18,'(a)') '#  Universe age at z_form   Galaxy age at z=0'
      WRITE(18,'(5X,F9.5,A4,11X,F9.5,A4)') age_form,' Gyr',
     .     tz(h0,om,ov,z0)-age_form,' Gyr'
      z_int=zmax-zmin 
      averr=avmax-avmin
c IF I/O in muJy, convert max and min fluxes in min and max Vega magnitudes,
c and err_min and err_p in magnitudes
c TO BE CHANGED
      IF (magtyp.eq.2) THEN
         aa=am_max
         bb=am_min
         am_min=-2.5D0*DLOG10(aa*1.D-12*0.5D0*(c/(wl(0)**2))
     .        *surf(0)/vega(0)) 
         am_max=-2.5D0*DLOG10(bb*1.D-12*0.5D0*(c/(wl(0)**2))
     .        *surf(0)/vega(0)) 
c         DO kk=1,n_filter
c            am0(kk)=-2.5*LOG10(am0(kk)*1.E-12*0.5*
c     .        (2.9979E+18/(wl(kk)**2))*surf(kk)/vega(kk)) 
c         END DO
      END IF

      OPEN(14,file=spectra1,status='unknown')
      lineh='#          ID     z  type   age'
      last=INDEX(lineh,'           ')
      DO i=1,n_filter           ! apparent magnitudes
         WRITE(cfilt(i),'(i3)') nfil(i)
         lineh(last:)='     '//cfilt(i)
         last=last+8
      END DO
      DO i=1,n_filter           ! absolute magnitudes
         lineh(last:)='     '//cfilt(i)
         last=last+8
      END DO
      lineh(last:)=
     &     '      A_V   LyForst     Log(M)       Log(M*)      SFR'
     &     //'   tau'
      last=last+60
      WRITE(14,'(a)') lineh(1:last)
      OPEN(15,file=spectra2,status='unknown')
      lineh='#    ID  '
      last=INDEX(lineh,'           ')
      DO i=1,n_filter
         lineh(last:)='    '//cfilt(i)
         last=last+8
      END DO
      DO i=1,n_filter
         lineh(last:)='  d'//cfilt(i)
         last=last+7
      END DO
      lineh(last:)='    z'
      last=last+5
      WRITE(15,'(a)') lineh(1:last)

c ------------------------------------------------------------------------
c homogeneous distribution in z and type, mag random in the input range
c ------------------------------------------------------------------------
      DO i_ob=1,nob
         z=z_int*ran1(iseed)+zmin ! random z 
         dl=d_l(h0,om,ov,z)     ! luminosity distance
         bmag_tmp=am_min+ran1(iseed)*(am_max-am_min) ! random mag in ref.filter
         av=avmin+averr*ran1(iseed) ! random Av
         ityp=INT(n_files*ran1(iseed))+1 ! random type

         IF (nlyf.eq.1) THEN
            ilyf=1
            fact_lyf=1.D0
         ELSE 
            ilyf=INT(nlyf*ran1(iseed))+1
            fact_lyf=(r_lyf**(ilyf-1))*(1.D0/r_lyf)
         END IF
         age_z=tz(h0,om,ov,z)   ! age of universe at z [Gyr]
         IF (i_age.eq.0) THEN
            age=age_z-age_form
         ELSE IF (i_age.eq.1) THEN
            age=(age_z-age_form)*ran1(iseed) ! random age [Gyr]
         END IF

c interpola anche qui!
         DO k=2,nagelog
            IF(LOG10(age*1.D9).ge.agelog(ityp,k-1).and.
     .           LOG10(age*1.D9).lt.agelog(ityp,k)) THEN
               jage1=k-1
               jage2=k
               GO TO 33
            END IF
         END DO
 33      tx=age
         t1=10**(agelog(ityp,jage1)-9)
         t2=10**(agelog(ityp,jage2)-9)
         a1=(t2-tx)/(t2-t1)
         a2=1.D0-a1
         amstar_tmp=a1*amstar(ityp,jage1)+a2*amstar(ityp,jage2)

         DO k=1,ks(ityp)-1
            IF (age.ge.t_bc(k)*1.D-9.and.age.lt.t_bc(k+1)*1.D-9) THEN
               i1=k
               i2=k+1
               GO TO 22
            END IF
         END DO
 22      DO i=1,iw(ityp)        !lambda
            fl1(i)=DBLE(f_bc(i,i1,ityp))
            fl2(i)=DBLE(f_bc(i,i2,ityp))
            ww(i)=DBLE(w_bc(i,ityp))
            IF (ww(i).lt.912.0D0) THEN
               fl1(i)=0.0D0
               fl2(i)=0.0D0
            END IF
         END DO
         tx=age
         t1=t_bc(i1)*1.D-9
         t2=t_bc(i2)*1.D-9
         a1=(t2-tx)/(t2-t1)
         a2=1.D0-a1
         DO i=1,iw(ityp)
            yz(i)=a1*fl1(i)+a2*fl2(i)
            yynu(i)=yz(i)*ww(i)*ww(i)/c ! f(nu) of template
            wwnu(i)=c/ww(i)     ! frequency of template
         END DO
c flux0 = flux of original SED
         IF (magtyp.eq.0.or.magtyp.eq.2) THEN
            flux0=filter(nfil(0),ww,yz,iw(ityp),z)
         ELSE IF (magtyp.eq.1) THEN
            l=0
            DO kk=1,np(nfil(0))
               wrnu(kk)=wrnuf(kk,0) ! frequency of R(nu)
               rrnu(kk)=rrnuf(kk,0) ! R(nu)
               flnu(kk)=rrnu(kk)*rlin(wrnu(kk)*(1.+z),wwnu,
     &              yynu,iw(ityp),l)
            END DO
            flux0=trapz1(wrnu,flnu,np(nfil(0)))*(1.D0+z)/(f2(0))
         END IF
c apply extinction
         IF (av.gt.0.0D0) THEN
            CALL red_spec(ww,yz,av,yob,1,iw(ityp),law_rd)
            DO i=1,iw(ityp)
               yz(i)=yob(i)
               yynu(i)=yz(i)*ww(i)*ww(i)/c ! f(nu) of template
               wwnu(i)=c/ww(i)  ! frequency of template
            END DO
         END IF
c apply lyman alpha forest
         CALL lyman_forest(ww,yz,iw(ityp),z)
         DO i=1,iw(ityp)
            yynu(i)=yz(i)*ww(i)*ww(i)/c ! f(nu) of template
            wwnu(i)=c/ww(i)     ! frequency of template
         END DO
c redshifted and z=0 fluxes for the reddened SED
         IF (magtyp.eq.0.or.magtyp.eq.2) THEN
            fluxz=filter(nfil(0),ww,yz,iw(ityp),z)
            fluxz0=filter(nfil(0),ww,yz,iw(ityp),z0)
         ELSE IF (magtyp.eq.1) THEN
            l=0
            DO kk=1,np(nfil(0))
               wrnu(kk)=wrnuf(kk,0) ! frequency of R(nu)
               rrnu(kk)=rrnuf(kk,0) ! R(nu)
               flnu(kk)=rrnu(kk)*rlin(wrnu(kk)*(1.+z),wwnu,
     &              yynu,iw(ityp),l)
            END DO
            fluxz=trapz1(wrnu,flnu,np(nfil(0)))*(1.D0+z)/(f2(0))
            l=0
            DO kk=1,np(nfil(0))
               flnu(kk)=rrnu(kk)*rlin(wrnu(kk)*(1.+z0),wwnu,
     &              yynu,iw(ityp),l)
            END DO
            fluxz0=trapz1(wrnu,flnu,np(nfil(0)))*(1.D0+z0)/(f2(0))
         END IF
         IF (fluxz.eq.0.D0) THEN
            WRITE(*,'(a,1x,f6.3,1x,a)') 'Object at redshift ',z, 
     .           'non detected in the reference filter'
            WRITE(*,*) 'Select a redder REF_FILTER or a lower Z_MAX'
            STOP
         END IF
c reference mag is apparent/absolute
         IF (ilim.eq.0) THEN
            bmag=bmag_tmp
c ... if the constraint is in absolute magnitude, find the apparent magitude
c ... in the reference filter
         ELSE
            IF (fluxz.gt.1.D-10) THEN
               IF (magtyp.eq.0) THEN
                  bmag=bmag_tmp+5.D0*DLOG10(dl)+25.D0+2.5D0*
     .                 DLOG10(fluxz0/fluxz)
               ELSE IF (magtyp.eq.1) THEN
                  bmag=bmag_tmp+5.D0*DLOG10(dl)+25.D0+2.5D0*
     .                 DLOG10(fluxz0/fluxz)+conv_mag(0)
               ELSE IF (magtyp.eq.2) THEN
                  bmag=bmag_tmp
               END IF
            ELSE
               bmag=99.D0
            END IF
         END IF
c find mag in reference filter with SED normalization
         IF (magtyp.eq.0.or.magtyp.eq.2) THEN
            amag_ref=-2.5D0*DLOG10(fluxz/vega(0))
            amag_ref0rf=-2.5D0*DLOG10(fluxz0/vega(0)) ! model absolute magnitude
            bmag0rf=bmag-5.D0*DLOG10(dl)-25.D0-
     .           2.5D0*DLOG10(fluxz0/fluxz) ! object absolute magnitude
         ELSE IF (magtyp.eq.1) THEN
            amag_ref=-2.5*DLOG10(fluxz)-48.6
            amag_ref0rf=-2.5*DLOG10(fluxz0)-48.6
            bmag0rf=bmag-5.D0*DLOG10(dl)-25.D0-
     .           2.5D0*DLOG10(fluxz0/fluxz) ! object absolute magnitude
         END IF
c difference between non-normalized mag and output mag
         diff_mag=amag_ref-bmag
         IF (magtyp.eq.0.or.magtyp.eq.2) THEN
            amag_ref0=-2.5D0*DLOG10(flux0/vega(0))         
         ELSE IF (magtyp.eq.1) THEN
            amag_ref0=-2.5*DLOG10(fluxz0)-48.6
         END IF
         b=10.**(-0.4*(bmag-amag_ref)) ! normalization factor
         b0=10.**(-0.4*(bmag0rf-amag_ref0rf)) ! rest frame normalization factor
         rnorm=b*dl*dl*factmass
         starmass=rnorm*amstar_tmp
c masses and star formation
         IF (tau(ityp).gt.1.D-8) THEN ! tau models
            sfrgal=rnorm*DEXP(-age/tau(ityp))/tau(ityp)*1.D-9 ! Msun/yr
            galmass=rnorm*(1.-DEXP(-age/tau(ityp)))
         ELSE IF (tau(ityp).lt.-1.D-8) THEN ! constant star formation
            sfrgal=rnorm ! Msun/yr
            galmass=rnorm*age*1.D9
         ELSE IF (ABS(tau(ityp)).lt.1.D-8) THEN ! SSP 
            sfrgal=0.D0
            galmass=rnorm
         END IF
c apparent magnitudes
         DO kk=1,n_filter
            flux=filter(nfil(kk),ww,yz,iw(ityp),z)
            IF (flux.gt.0.D0) THEN
               IF (magtyp.eq.0) THEN
                  amag(kk)=-2.5D0*DLOG10(flux/vega(kk))-diff_mag
               ELSE IF (magtyp.eq.1) THEN
                  l=0
                  DO j=1,np(nfil(kk))
                     wrnu(j)=wrnuf(j,kk) ! frequency of R(nu)
                     rrnu(j)=rrnuf(j,kk) ! R(nu)
                     flnu(j)=rrnu(j)*rlin(wrnu(j)*(1.+z),wwnu,
     &                    yynu,iw(ityp),l)
                  END DO
                  fluxz=trapz1(wrnu,flnu,np(nfil(kk)))*(1.D0+z)/
     &                 (f2(kk))
                  amag(kk)=-2.5D0*DLOG10(b*fluxz)-48.60
               ELSE IF (magtyp.eq.2) THEN
                  amag(kk)=-2.5D0*DLOG10(flux/vega(kk))-diff_mag
                  fl=vega(kk)*10.D0**(-0.4D0*amag(kk))/surf(kk)
                  fl_jy(kk)=fl*(wl(kk)**2/(2.9979D+18))*1.D+29
               END IF
            ELSE 
               IF (magtyp.eq.0.or.magtyp.eq.1) THEN
                  amag(kk)=99.D0
               ELSE IF (magtyp.eq.2) THEN
                  fl_jy(kk)=-99.D0
               END IF
            END IF
         END DO
c absolute magnitudes with only k-correction
         DO kk=0,n_filter
            fluxz=filter(nfil(kk),ww,yz,iw(ityp),z)
            fluxz0=filter(nfil(kk),ww,yz,iw(ityp),z0)
            IF (fluxz.gt.1.D-10) THEN
               amabs(kk)=amag(kk)-5.D0*DLOG10(dl)-25.D0-
     .              2.5D0*DLOG10(fluxz0/fluxz)
            ELSE
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c compute the absolute magnitude with the nearest detected filter...
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               amabs(kk)=-99.D0
            END IF
         END DO
c model catalog (no noise added)
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
            WRITE(14,fmt) i_ob,z,ityp,age,(amag(kk),kk=1,n_filter),
     &           (amabs(kk),kk=1,n_filter),av,fact_lyf,
     &           DLOG10(galmass),DLOG10(starmass),sfrgal,b,amstar_tmp,
     &           tau(ityp)
         ELSE
            WRITE(14,fmtjy) i_ob,z,ityp,age,(fl_jy(kk),kk=1,n_filter),
     &           (amabs(kk),kk=1,n_filter),av,fact_lyf,
     &           DLOG10(galmass),DLOG10(starmass),sfrgal,b,amstar_tmp,
     &           tau(ityp)
         END IF
c errors
         IF (inoise.eq.1) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO kk=1,n_filter
                  err_p(kk)=1.D0
                  IF (amag(kk).ne.99.D0) THEN 
                     sn=sn0(kk)*10.D0**(-0.4D0*(amag(kk)-am0(kk)))
                     IF (sn.lt.1.D0) THEN 
                        amag(kk)=99.D0
                     ELSE
                        sig=DSQRT((2.5D0*DLOG10(1.D0+1.D0/sn))**2
     .                       +err_min**2)
                        dif=rangauss(iseed)
                        amag(kk)=amag(kk)+dif*sig
                        err_p(kk)=sig
                     END IF
                  END IF
               END DO
            ELSE IF (magtyp.eq.2) THEN
               DO kk=1,n_filter
                  IF (fl_jy(kk).ge.0.D0) THEN
                     sn=sn0(kk)*fl_jy(kk)/am0(kk)
                     IF (sn.lt.1.D0) THEN 
                        fl_jy(kk)=-99.D0
                     ELSE
                        sig=DSQRT((fl_jy(kk)/sn)**2+err_min**2)
                        dif=rangauss(iseed)
                        fl_jy(kk)=fl_jy(kk)+dif*sig
                        err_p(kk)=sig
c check magnitudes...
                        fl=(fl_jy(kk))*1.D-29*
     .                       (2.9979D+18/wl(kk)**2)
                        am=-2.5D0*DLOG10(fl*surf(kk)/vega(kk))
                        fler=(err_p(kk))*1.D-29*
     .                       (2.9979D+18/wl(kk)**2)
                        er=2.5D0/DLOG(10.D0)*fler/fl
                     END IF
                  END IF
               END DO
            END IF
         ELSE IF (inoise.eq.0) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO kk=1,n_filter
                  IF (amag(kk).ne.99.D0) THEN 
                     sig=err_p(kk)
                     dif=rangauss(iseed)
                     amag(kk)=amag(kk)+dif*sig
                  END IF
               END DO
            ELSE
               DO kk=1,n_filter
                  IF (fl_jy(kk).ge.0.D0) THEN
                     sn=sn0(kk)*10.D0**(-0.4D0*(amag(kk)-am0(kk)))
                     IF (sn.lt.1.D0) THEN 
                        fl_jy(kk)=-99.D0
                     ELSE
                        sig=err_p(kk)
                        dif=rangauss(iseed)
                        fl_jy(kk)=fl_jy(kk)+dif*sig
                     END IF
                  END IF
               END DO
            END IF
         END IF
c catalog with errors
         IF (magtyp.eq.0.or.magtyp.eq.1) THEN
            WRITE(15,fmt2) i_ob,(amag(kk),kk=1,n_filter),
     .           (err_p(kk),kk=1,n_filter),z
         ELSE IF (magtyp.eq.2) THEN
            WRITE(15,fmt2jy) i_ob,(fl_jy(kk),kk=1,n_filter),
     .           (err_p(kk),kk=1,n_filter),z
         END IF
      END DO
      CLOSE(14)
      CLOSE(15)

      call cpu_time(time_tot)
      WRITE(*,'(a)') ' Done !!!'
      WRITE(*,*) 'Total CPU time involved :', time_tot, ' seconds'
      WRITE(18,'(a,1x,f8.2,1x,a)') '#  Total CPU time involved :',  
     .     time_tot,' seconds'
      CLOSE(18)
      STOP
 25   STOP 'Error opening synthetic spectra files'
 26   STOP 'Error opening .4color files'
 78   STOP 'Error opening templates file'
 80   STOP 'Error opening filters file'
 81   STOP 'Error reading filters file (format: #filter s/n mag)'
 82   STOP 'Error reading filters file (format: #filter sigma)'
 3    STOP 'Program exits because of error reading A0 V s.e.d. file'
      END
c............................................................
      FUNCTION f_sn(am)
      REAL*8 f_sn,am,sn_0,am_0
      COMMON/s2n/sn_0,am_0
      f_sn=sn_0*10.D0**(-0.4D0*(am-am_0))-1.D0
      RETURN
      END
c............................................................

      REAL*8 FUNCTION ran1(idum)
      REAL*8 rm1,rm2,rr
      DIMENSION rr(97)
      PARAMETER (m1=259200,ia1=7141,ic1=54773,rm1=3.8580247D-6)
      PARAMETER (m2=134456,ia2=8121,ic2=28411,rm2=7.4373773D-6)
      PARAMETER (m3=243000,ia3=4561,ic3=51349)
      SAVE rr,ix1,ix2,ix3
      DATA iff /0/
      IF (idum.lt.0.or.iff.eq.0) THEN
         iff=1
         ix1=MOD(ic1-idum,m1)
         ix1=MOD(ia1*ix1+ic1,m1)
         ix2=MOD(ix1,m2)
         ix1=MOD(ia1*ix1+ic1,m1)
         ix3=MOD(ix1,m3)
         DO j=1,97
            ix1=MOD(ia1*ix1+ic1,m1)
            ix2=MOD(ia2*ix2+ic2,m2)
            rr(j)=DBLE((FLOAT(ix1)+FLOAT(ix2)*rm2)*rm1)
         END DO
         idum=1
      END IF
      ix1=MOD(ia1*ix1+ic1,m1)
      ix2=MOD(ia2*ix2+ic2,m2)
      ix3=MOD(ia3*ix3+ic3,m3)
      j=1+(97*ix3)/m3
      IF (j.gt.97.or.j.lt.1) PAUSE
      ran1=rr(j)
      rr(j)=DBLE((FLOAT(ix1)+FLOAT(ix2)*rm2)*rm1)
      RETURN
      END

c............................................................
c  Normal (Gaussian) deviates with unit variance
c  Returns normally distributed deviate with zero mean
c............................................................

      FUNCTION rangauss(idum)
      REAL*8 a,b,rg,rangauss,ran1
      INTEGER idum
 50   a=ran1(idum)
      b=ran1(idum)
      b=1.7156D0*(b-0.5D0)
      rg=b/a
      IF (rg**2.gt.-4.D0*DLOG(a)) GO TO 50
      rangauss=rg
      RETURN
      END
c............................................................
c Zero of function func with bisection

      FUNCTION zero(func,xl,xu,err)
      REAL*8 zero, func, xl, xu, x1, x2, xnew, err, test, errp
      INTEGER itmax
      PARAMETER (itmax=5000)
      EXTERNAL func
      IF (func(xl)*func(xu).gt.0.D0) THEN
         STOP ' ahi! zero non bracketed ...'
      END IF
      x1=xl
      x2=xu
      DO i=1,itmax
         xnew=(x2+x1)*0.5D0
         IF (x1+x2.gt.1.D-12) THEN
            errp=ABS((x2-x1)/(x2+x1))*100.D0
         END IF
         test=func(x1)*func(xnew)
         IF (test.eq.0.D0) THEN
            errp=0.D0
         ELSE
            IF (test.lt.0.D0) THEN
               x2=xnew
            ELSE
               x1=xnew
            END IF
         END IF
         IF (errp.le.err) GO TO 20
      END DO
 20   zero=xnew
      RETURN
      END

c............................................................
c ..... Luminosity distance [Mpc]
 
      FUNCTION d_l(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 h0,om,ov,z,za,c,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.9979D+5,nstep=100)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
      IF (za.lt.1.D-5) THEN
         z=1.D-5
      ELSE
         z=za
      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_l=c/h0*d_l ! luminosity distance in Mpc
      RETURN
      END
c ----------------------------------------------------------------------
