c equivalent of red_spec for hyperzmass
      SUBROUTINE red_spec(wl,fl,av,yob,kred,iwavl,law_rd)
c     Reads a spectrum and calculates the new one with internal
c     reddening. 
c     law_rd=1 : the standard variation of absorption with wavelength 
c                is used (Allen, 1976) - MW
c     law_rd=2 : the analytic fit of Seaton (1979) curve by 
c                Fitzpatrick (1986) - MW 
c     law_rd=3 : Fitzpatrick (1986) - LMC
c     law_rd=4 : Prevot et al. (1984) and Bouchet et al. (1985) - SMC
c     law_rd=5 : Calzetti (2000) - SB
c    
      IMPLICIT NONE
      INTEGER kred,iwavl,law_rd,mxz,mxage_pg,mxage,mxtyp,mxfil,mxred,
     .     mxlyf,mxwl,ik,i
      REAL*8 yob,alambda,wl,fl,wab,amab,aab,av,ff,ff11,ff12,slope,rv,
     .     ccc,al0,ga,c1,c2,c3,c4,p11,p12,ff99,ff100,slope2,slope1,
     .     p,ala
      INCLUDE 'dimensionmass.dec'
      DIMENSION yob(mxwl),wl(mxwl),fl(mxwl),wab(30),amab(30),aab(30)
c ..... 1. Allen (1976) : wab = lambda in A, amab = k(lambda)/R, 
c          A(lambda) = k(lambda)*E(B-V) = amab*A_V ; R = 3.1

      IF (law_rd.eq.1) THEN
         rv=3.1D0
         wab(1)=1000.D0
         amab(1)=4.2D0
         wab(2)=1110.D0
         amab(2)=3.7D0
         wab(3)=1250.D0
         amab(3)=3.3D0
         wab(4)=1430.D0
         amab(4)=3.D0
         wab(5)=1670.D0
         amab(5)=2.7D0
         wab(6)=2000.D0
         amab(6)=2.8D0
         wab(7)=2220.D0
         amab(7)=2.9D0
         wab(8)=2500.D0
         amab(8)=2.30D0
         wab(9)=2850.D0
         amab(9)=1.97D0
         wab(10)=3330.D0
         amab(10)=1.69D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=1,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).le.wab(1)) THEN 
               ccc=(aab(1)-aab(2))/(wab(2)-wab(1))
               alambda=aab(1)+(wab(1)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.wab(1).and.wl(ik).lt.wab(19)) THEN
               DO i=1,19
                  IF (wl(ik).ge.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN

c ..... 2. Seaton (1979) - Fitzpatrick fit : 
c                       for lambda < 1200 A slope from 1100-1200
c                       for lambda > 3650 A points from Allen
c                       ff = E(lambda-V)/E(B-V) = k(lambda)-R
c                       A(lambda)=A_V*(ff/R +1) ; R = 3.1

      ELSE IF (law_rd.eq.2) THEN
         rv=3.1D0
         al0=4.595D0
         ga=1.051D0
         c1=-0.38D0
         c2=0.74D0
         c3=3.96D0
         c4=0.26D0
         call red(1100.D0,al0,ga,c1,c2,c3,c4,ff)
         ff11=ff
         call red(1200.D0,al0,ga,c1,c2,c3,c4,ff)
         ff12=ff
         slope=(ff12-ff11)/100.D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=11,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).ge.1200.D0.and.wl(ik).le.3650.D0) THEN
               call red(wl(ik),al0,ga,c1,c2,c3,c4,ff)
               alambda=av*(ff/rv+1.D0) 
            ELSE IF (wl(ik).lt.1200.D0) THEN
               ff=ff11+(wl(ik)-1100.D0)*slope
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.3650.D0.and.wl(ik).lt.wab(19)) THEN
               DO i=11,19
                  IF (wl(ik).ge.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN
      
c ..... 3. Fitzpatrick (1986) : 
c                       for lambda < 1200 A slope derived from 1100-1200
c                       for lambda > 3330 A points from Allen
c                       ff = E(lambda-V)/E(B-V) = k(lambda)-R
c                       A(lambda) = A_V*(ff/R +1) ; R = 3.1

      ELSE IF (law_rd.eq.3) THEN
         rv=3.1D0
         al0=4.608D0
         ga=0.994D0
         c1=-0.69D0
         c2=0.89D0
         c3=2.55D0
         c4=0.50D0
         call red(1100.D0,al0,ga,c1,c2,c3,c4,ff)
         ff11=ff
         call red(1200.D0,al0,ga,c1,c2,c3,c4,ff)
         ff12=ff
         slope=(ff12-ff11)/100.D0
         wab(10)=3330.D0
         amab(10)=1.682D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=10,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).ge.1200.D0.and.wl(ik).le.3330.D0) THEN
               call red(wl(ik),al0,ga,c1,c2,c3,c4,ff)
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).lt.1200.D0) THEN
               ff=ff11+(wl(ik)-1100.D0)*slope
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.3330.D0.and.wl(ik).lt.wab(19)) THEN
               DO i=10,19
                  IF (wl(ik).ge.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN

c ..... 4. Prevot (1984) and Bouchet (1985) :
c                        wab = lambda in A,  
c                        amab = E(lambda-V)/E(B-V) = k(lambda)-R
c                        A(lambda) = A_V*(amab/R +1)
c                        N.B. R = 2.72

         ELSE IF (law_rd.eq.4) THEN
            rv=2.72D0
            wab(1)=1275.D0
            amab(1)=13.54D0
            wab(2)=1330.D0
            amab(2)=12.52D0
            wab(3)=1385.D0
            amab(3)=11.51D0
            wab(4)=1435.D0
            amab(4)=10.80D0
            wab(5)=1490.D0
            amab(5)=9.84D0
            wab(6)=1545.D0
            amab(6)=9.28D0
            wab(7)=1595.D0
            amab(7)=9.06D0
            wab(8)=1647.D0
            amab(8)=8.49D0
            wab(9)=1700.D0
            amab(9)=8.01D0
            wab(10)=1755.D0
            amab(10)=7.71D0
            wab(11)=1810.D0
            amab(11)=7.17D0
            wab(12)=1860.D0
            amab(12)=6.90D0
            wab(13)=1910.D0
            amab(13)=6.76D0
            wab(14)=2000.D0
            amab(14)=6.38D0
            wab(15)=2115.D0
            amab(15)=5.85D0
            wab(16)=2220.D0
            amab(16)=5.30D0
            wab(17)=2335.D0
            amab(17)=4.53D0
            wab(18)=2445.D0
            amab(18)=4.24D0
            wab(19)=2550.D0
            amab(19)=3.91D0
            wab(20)=2665.D0
            amab(20)=3.49D0
            wab(21)=2778.D0
            amab(21)=3.15D0
            wab(22)=2890.D0
            amab(22)=3.00D0
            wab(23)=2995.D0
            amab(23)=2.65D0
            wab(24)=3105.D0
            amab(24)=2.29D0
            wab(25)=3704.D0
            amab(25)=1.81D0
            wab(26)=4255.D0
            amab(26)=1.00D0
            wab(27)=5291.D0
            amab(27)=0.00D0
            wab(28)=12500.D0
            amab(28)=-2.02D0
            wab(29)=16500.D0
            amab(29)=-2.36D0
            wab(30)=22000.D0
            amab(30)=-2.47D0

            DO i=1,30
               aab(i)=av*(amab(i)/rv+1.D0)
            END DO

            DO ik=1,iwavl
               IF (wl(ik).le.wab(1)) THEN !extrapol at short wavelengths
                  ccc=(aab(1)-aab(2))/(wab(2)-wab(1))
                  alambda=aab(1)+(wab(1)-wl(ik))*ccc
               ELSE IF(wl(ik).ge.wab(30)) THEN !extrapol at high wavelengths
                  ccc=(aab(29)-aab(30))/(wab(30)-wab(29))
                  alambda=aab(29)+(wab(29)-wl(ik))*ccc  
               ELSE IF (wl(ik).gt.wab(1).and.wl(ik).lt.wab(30)) THEN
                  DO i=1,30
                     IF (wl(ik).gt.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                        ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                        alambda=aab(i)+(wab(i)-wl(ik))*ccc
                     END IF
                  END DO
               END IF   
               IF (alambda.lt.0.D0) alambda=0.D0
               IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
               IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
            END DO
            RETURN


c ..... Calzetti (2000) : 
c                   for lambda < 1200 A slope derived from 1100-1200 A
c                   for lambda > 22000A slope derived from 21900-22000 A
c                   ff = k(lambda); A(lambda) = A_V*k(lambda)/R ; R = 4.05

      ELSE IF (law_rd.eq.5) THEN
         rv=4.05D0
         p11=1.D0/0.11D0
         ff11=2.659D0*(-2.156D0+1.509D0*p11-0.198D0*p11**2
     .        +0.011D0*p11**3)+rv
         p12=1.D0/0.12D0
         ff12=2.659D0*(-2.156D0+1.509D0*p12-0.198D0*p12**2
     .        +0.011D0*p12**3)+rv
         slope1=(ff12-ff11)/100.D0
         ff99=2.659D0*(-1.857D0+1.040D0/2.19D0)+rv
         ff100=2.659D0*(-1.857D0+1.040D0/2.2D0)+rv
         slope2=(ff100-ff99)/100.D0
         DO ik=1,iwavl
            IF (wl(ik).lt.1.D-12) THEN
               IF (kred.eq.1) yob(ik)=0.D0 
               IF (kred.eq.2) yob(ik)=fl(ik) 
            ELSE
               ala=wl(ik)*1.D-4 !wavelength in microns
               p=1.D0/ala
               IF (ala.ge.0.63D0.and.ala.le.2.2D0) THEN
                  ff=2.659D0*(-1.857D0+1.040D0*p)+rv
               ELSE IF (ala.ge.0.12D0.and.ala.lt.0.63D0) THEN
                  ff=2.659D0*(-2.156D0+1.509D0*p-0.198D0*p**2+
     .                 0.011D0*p**3)+rv
               ELSE IF (ala.lt.0.12D0) THEN
                  ff=ff11+(wl(ik)-1100.D0)*slope1
               ELSE IF (ala.gt.2.2D0) THEN
                  ff=ff99+(wl(ik)-21900.D0)*slope2
               END IF
               alambda=av*ff/rv
               IF (alambda.lt.0.D0) alambda=0.D0
               IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
               IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
            END IF
         END DO
         RETURN
      END IF

      WRITE(*,*) ' No reddening law is given.....'
      RETURN
      END

c ----------------------------------------------------------------------
      SUBROUTINE red(alan,al0,ga,c1,c2,c3,c4,ff)
      IMPLICIT NONE
      REAL*8 ala,alan,al0,ga,c1,c2,c3,c4,ff,p,t1,t2

c.......According to Fitzpatrick, 86

      ala=alan*1.D-4           !wavelength in microns
      p=1.0D0/ala
      IF (p.lt.5.9D0) c4=0.0D0
      t1=c3/(((p-(al0**2/p))**2)+ga*ga)
      t2=c4*(0.539D0*((p-5.9D0)**2)+0.0564D0*((p-5.9D0)**3))
      ff=c1+c2*p+t1+t2
      RETURN
      END


