      SUBROUTINE zfit_min(sed_abcz,iagem,itypem,av,zmin_f,zmax_f,
     .     dz_f,chi2,zop)
      IMPLICIT NONE
      INTEGER law_rd,n_filter,nfil,iw,i_lyman,k,kk,i,iagem,itypem,ntyp,
     .     nz_f,i_min,mxwl,mxwl_bc,mxwl_as,mxwl_pg,mxfil,mxtyp,mxtyp_bc,
     .     mxtyp_as,mxtyp_pg,mxz,mxage,mxage_bc,mxage_pg,mxred,mxlyf,
     .     magtyp,l,iread,jread,nf,np,mxft,mxwf
      REAL*8 dif,yob,y,y1,fluz,fl2,ww,f_bc,f_as,f_pg,fl,err_fl,r,
     .     fact_lyf,av,zmin_f,zmax_f,dz_f,chi2,zop,surf,zz,filter,
     .     f2,rlin,trapz1,yynu,wwnu,wrnuf,rrnuf,wrnu,rrnu,flnu,c
      REAL*8 bm,wt,sxx,sxy,b
      REAL w_bc,w_as,w_pg
      PARAMETER (mxage_bc=51)
      INCLUDE 'dimension.dec'
      INCLUDE 'filter.dec'
      PARAMETER (mxtyp=mxtyp_bc+mxtyp_as+mxtyp_pg)
      CHARACTER*2 sed_abcz*2
      DIMENSION dif(101),yob(mxwl),y(mxwl),y1(mxwl),fluz(mxfil),
     .     fl2(mxfil),ww(mxwl),yynu(mxwl),wwnu(mxwl),wrnu(mxwf),
     .     rrnu(mxwf),flnu(mxwf)

      EXTERNAL filter,rlin,trapz1
      COMMON/et1/surf(0:mxfil)
      COMMON/et2/fl(mxfil),err_fl(mxfil)
      COMMON/et2a/w_bc(mxwl_bc,mxtyp_bc),f_bc(mxwl_bc,mxage_bc,mxtyp_bc)
      COMMON/et2b/w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,1,mxtyp_as)
      COMMON/et2c/w_pg(mxwl_pg,mxtyp_pg),f_pg(mxwl_pg,mxage_pg,mxtyp_pg)
      COMMON/et3/law_rd,magtyp
      COMMON/et4/n_filter,nfil(0:mxfil),iw(mxtyp),i_lyman(mxfil)
      COMMON/et5/bm
      COMMON/et6/ntyp(mxtyp)
      COMMON/lyf_sigma/fact_lyf
      COMMON/filtnu/f2(0:mxfil),wrnuf(mxwf,0:mxfil),rrnuf(mxwf,0:mxfil)
      
      c=2.9979D+18              ! speed of light in AA/s
      nz_f=NINT((zmax_f-zmin_f)/dz_f)+1
      chi2=1.D+12
      IF (sed_abcz.eq.'BC') THEN
         DO k=1,iw(itypem) 
            y(k)=f_bc(k,iagem,ntyp(itypem)) !age et type minimum
            ww(k)=DBLE(w_bc(k,ntyp(itypem)))
         END DO
      ELSE IF (sed_abcz.eq.'AS'.or.sed_abcz.eq.'A ') THEN
         DO k=1,iw(itypem) 
            y(k)=f_as(k,iagem,ntyp(itypem)) !age et type minimum
            ww(k)=DBLE(w_as(k,ntyp(itypem)))
         END DO
      ELSE IF (sed_abcz.eq.'PG') THEN
         DO k=1,iw(itypem) 
            y(k)=f_pg(k,iagem,ntyp(itypem)) !age et type minimum
            ww(k)=DBLE(w_pg(k,ntyp(itypem)))
         END DO
      END IF
      IF (av.gt.0.D0.and.law_rd.ne.0) THEN
         CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd)
         DO k=1,iw(itypem)
            y(k)=yob(k)
         END DO
      END IF
      DO i=2,nz_f-1             !Scan in z excluding limits of range
         zz=zmin_f+(i-1)*dz_f
         DO k=1,iw(itypem)
            y1(k)=y(k)
         END DO
         CALL lyman_forest(ww,y1,iw(itypem),zz)
         IF (magtyp.eq.1) THEN
            DO k=1,iw(itypem)
               yynu(k)=y1(k)*ww(k)*ww(k)/c ! f(nu) of template
               wwnu(k)=c/ww(k)  ! frequency of template
            END DO
         END IF

         dif(i)=0.0D0
         sxx=0.D0
         sxy=0.D0
         b=0.D0
         DO k=1,n_filter
            IF (magtyp.eq.1) THEN
               l=0
               DO kk=1,np(nfil(k))
                  wrnu(kk)=wrnuf(kk,k) ! frequency of R(nu)
                  rrnu(kk)=rrnuf(kk,k) ! R(nu)
                  flnu(kk)=rrnu(kk)*
     &                 rlin(wrnu(kk)*(1.+zz),wwnu,
     &                 yynu,iw(itypem),l)
               END DO
               fluz(k)=trapz1(wrnu,flnu,np(nfil(k)))
     &                          *(1.D0+zz)/f2(k)
            ELSE
               fluz(k)=filter(nfil(k),ww,y1,iw(itypem),zz)/surf(k)
            END IF
         END DO

         DO k=1,n_filter
            IF (fl(k).ge.0.) THEN ! no oof objects
               IF (fluz(k).lt.1.D-12.and.i_lyman(k).eq.1) THEN
                  fl2(k)=0.D0
               ELSE
                  fl2(k)=fl(k)
                  wt=1.D0/(err_fl(k)**2)
                  sxx=sxx+(fluz(k)**2)*wt
                  sxy=sxy+fluz(k)*fl2(k)*wt
               END IF
            ELSE
               fl2(k)=-1.D0
            END IF
         END DO
         b=sxy/sxx
         DO k=1,n_filter
            IF (fl2(k).ge.0.D0) THEN ! no oof objects
               dif(i)=dif(i)+((fl2(k)-b*fluz(k))/err_fl(k))**2
            END IF
         END DO

         IF (dif(i).lt.chi2) THEN
            chi2=dif(i)
            i_min=i
            bm=b
         END IF
      END DO

      zop=zmin_f+(i_min-1)*dz_f

      RETURN
      END


